Unit aee8e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AMA1E_p;

procedure aee8e(var A :Array of Extended; var B :Array of Extended;
                N :Integer; var L :Extended; var U :Extended;
                var M1 :Integer; var M2 :Integer;
                var RU :Array of Extended; var W :Array of Extended);

implementation

procedure aee8e(var A :Array of Extended; var B :Array of Extended;
                N :Integer; var L :Extended; var U :Extended;
                var M1 :Integer; var M2 :Integer;
                var RU :Array of Extended; var W :Array of Extended);
var
I,J,M,M3,N1,K1,P1,I1,I2,K :Integer;
X,V,Z,Y,S,R,Q,EPS,WMIN2,HM :Extended;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
WMIN2 := SYS051;
M1 := 0;
M2 := 0;
if ( N <> 1 ) 
 then goto _1;
if ( A[0] < L ) or ( A[0] >= U ) 
 then goto _18;
W[0] := A[0];
M2 := 1;
M1 := 1;
goto _18;
_1:
AMA1E(A,B,N,Q,R,HM,P1);
if ( P1 = 0 ) 
 then goto _2;
U := U*HM;
L := L*HM;
_2:
X := U;
M := 7;
_3:
M3 := 0;
V := A[0]-X;
if ( V < 0.0e0 ) 
 then M3 := 1;
for J:=2 to N do
 begin
  Z := B[J-1];
  if ( V <> 0.0e0 ) 
   then goto _4;
  Y := Abs(Z)/WMIN2;
  goto _5;
_4:
  Y := (Z/V)*Z;
_5:
  V := A[J-1]-X-Y;
  if ( V < 0.0e0 ) 
   then M3 := M3+1;
_6:
 end;
if ( M=7 ) then goto _7 else
if ( M=8 ) then goto _8 else
if ( M=12 ) then goto _12;
_7:
M2 := M3;
if ( M2 = 0 ) 
 then goto _18;
M := 8;
X := L;
goto _3;
_8:
M1 := M3+1;
if ( (M2-M3) = 0 ) 
 then goto _18;
EPS := EMax1(Abs(R),Abs(Q))*WMIN2;
S := 2.e0*WMIN2;
if ( L > Q ) 
 then Q := L;
if ( U < R ) 
 then R := U;
for I:=M1 to M2 do
 begin
  W[I-1] := Q;
_9:
  RU[I-1] := R;
 end;
M := 12;
N1 := M1+M2;
//for I1:=M1 to M2 do
//  , ..        goto
I1:=M1;
while I1<=M2 do
 begin
  K := N1-I1;
  Q := W[K-1];
  Z := RU[K-1];
  if ( R > Z ) 
   then R := Z;
  K1 := M1+K;
  for I2:=M1 to K do
   begin
    I := K1-I2;
    if ( Q >= W[I-1] ) 
     then goto _10;
    Q := W[I-1];
    goto _11;
_10:
   end;
_11:
  X := (Q+R)*0.5e0;
  if ( R-Q <= (Abs(R)+Abs(Q))*S+EPS ) 
   then goto _15;
  goto _3;
_12:
  if ( M3 >= K ) 
   then goto _14;
  Q := X;
  if ( M3 >= M1 ) 
   then goto _13;
  W[M1-1] := X;
  goto _11;
_13:
  K1 := M3+1;
  W[K1-1] := X;
  if ( RU[M3-1] > X ) 
   then RU[M3-1] := X;
  goto _11;
_14:
  R := X;
  goto _11;
_15:
  W[K-1] := X;
_16:
  inc(I1); //  
 end;
if ( P1 = 0 )
 then goto _18;
HM := 1.e0/HM;
for I:=M1 to M2 do
 begin
_17:
  W[I-1] := W[I-1]*HM;
 end;
_18:
end;

end.
